using System.Text.Json;
using System.Text.Json.Serialization;

namespace View_by_Distance.Duplicate.Search.Models;

public record AppSettings(string Company,
                          bool IndexOnly,
                          int MaxDegreeOfParallelism,
                          string OutputExtension,
                          bool Reverse,
                          string WorkingDirectoryName)
{

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, AppSettingsSourceGenerationContext.Default.AppSettings);
        return result;
    }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(AppSettings))]
internal partial class AppSettingsSourceGenerationContext : JsonSerializerContext
{
}