using MetadataExtractor;
using System.Collections.ObjectModel;

namespace View_by_Distance.Metadata.Models.Stateless.Methods;

public interface IMetadata
{

    enum DistanceUnit
    {
        Miles,
        NauticalMiles,
        Kilometers,
        Meters
    }

    ReadOnlyDictionary<string, MetadataExtractorDirectory> TestStatic_GetKeyValuePairs(IReadOnlyList<MetadataExtractor.Directory> directories) =>
        GetKeyValuePairs(directories);
    static ReadOnlyDictionary<string, MetadataExtractorDirectory> GetKeyValuePairs(IReadOnlyList<MetadataExtractor.Directory> directories) =>
        new(Metadata.GetKeyValuePairs(directories));

    string? TestStatic_GetModel(IReadOnlyList<MetadataExtractor.Directory> directories) =>
        GetModel(directories);
    static string? GetModel(IReadOnlyList<MetadataExtractor.Directory> directories) =>
        Metadata.GetModel(directories);

    string? TestStatic_GetFaceEncoding(IReadOnlyList<MetadataExtractor.Directory> directories) =>
        GetFaceEncoding(directories);
    static string? GetFaceEncoding(IReadOnlyList<MetadataExtractor.Directory> directories) =>
        Metadata.GetFaceEncoding(directories);

    string? TestStatic_GetOutputResolution(IReadOnlyList<MetadataExtractor.Directory> directories) =>
        GetOutputResolution(directories);
    static string? GetOutputResolution(IReadOnlyList<MetadataExtractor.Directory> directories) =>
        Metadata.GetOutputResolution(directories);

    GeoLocation? TestStatic_GeoLocation(IReadOnlyList<MetadataExtractor.Directory> directories) =>
        GeoLocation(directories);
    static GeoLocation? GeoLocation(IReadOnlyList<MetadataExtractor.Directory> directories) =>
        Metadata.GeoLocation(directories);

    GeoLocation? TestStatic_GeoLocation(ReadOnlyDictionary<string, MetadataExtractorDirectory> metadataExtractorDirectories) =>
        GeoLocation(metadataExtractorDirectories);
    static GeoLocation? GeoLocation(ReadOnlyDictionary<string, MetadataExtractorDirectory> metadataExtractorDirectories) =>
        Metadata.GeoLocation(metadataExtractorDirectories);

    double? TestStatic_GetDistance(double originLatitude, double originLongitude, double destinationLatitude, double destinationLongitude, int decimalPlaces = 1, DistanceUnit distanceUnit = DistanceUnit.Miles) =>
        GetDistance(originLatitude, originLongitude, destinationLatitude, destinationLongitude, decimalPlaces, distanceUnit);
    static double? GetDistance(double originLatitude, double originLongitude, double destinationLatitude, double destinationLongitude, int decimalPlaces = 1, DistanceUnit distanceUnit = DistanceUnit.Miles) =>
        Metadata.GetDistance(originLatitude, originLongitude, destinationLatitude, destinationLongitude, decimalPlaces, distanceUnit);

}